com.fasterxml.jackson.dataformat.protobuf

## Class ProtobufMapper

- java.lang.Object
- - com.fasterxml.jackson.core.TreeCodec
  - - com.fasterxml.jackson.core.ObjectCodec
    - - com.fasterxml.jackson.databind.ObjectMapper
      - - com.fasterxml.jackson.dataformat.protobuf.ProtobufMapper

- All Implemented Interfaces:
    com.fasterxml.jackson.core.Versioned, Serializable

      public class ProtobufMapper
      extends com.fasterxml.jackson.databind.ObjectMapper

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `com.fasterxml.jackson.databind.ObjectMapper.DefaultTypeResolverBuilder, com.fasterxml.jackson.databind.ObjectMapper.DefaultTyping`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected DescriptorLoader` | `_descriptorLoader` Lazily constructed instance of `DescriptorLoader`, used for loading structured protoc definitions from multiple files.
    `protected ProtobufSchemaLoader` | `_schemaLoader`

    - ### Fields inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `_configOverrides, _deserializationConfig, _deserializationContext, _injectableValues, _jsonFactory, _mixIns, _registeredModuleTypes, _rootDeserializers, _serializationConfig, _serializerFactory, _serializerProvider, _subtypeResolver, _typeFactory, DEFAULT_ANNOTATION_INTROSPECTOR, DEFAULT_BASE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `ProtobufMapper()`
    `` | `ProtobufMapper(ProtobufFactory f)`
    `protected` | `ProtobufMapper(ProtobufMapper src)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ProtobufMapper` | `copy()`
    `DescriptorLoader` | `descriptorLoader()` Accessors that may be used instead of convenience `loadDescriptorSet` methods, if alternate sources need to be used.
    `ProtobufSchema` | `generateSchemaFor(Class<?> type)` Convenience method for constructing protoc definition that matches given Java type.
    `ProtobufSchema` | `generateSchemaFor(com.fasterxml.jackson.databind.JavaType type)` Convenience method for constructing protoc definition that matches given Java type.
    `ProtobufFactory` | `getFactory()`
    `FileDescriptorSet` | `loadDescriptorSet(File src)`
    `FileDescriptorSet` | `loadDescriptorSet(InputStream src)`
    `FileDescriptorSet` | `loadDescriptorSet(URL src)`
    `ProtobufSchemaLoader` | `schemaLoader()` Accessor for reusable `ProtobufSchemaLoader` which can be used for loading protoc definitions from files and other external sources.
    `void` | `setSchemaLoader(ProtobufSchemaLoader l)`
    `com.fasterxml.jackson.core.Version` | `version()`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ObjectMapper

      `_checkInvalidCopy, _configAndWriteValue, _convert, _findRootDeserializer, _initForReading, _initForReading, _newReader, _newReader, _newWriter, _newWriter, _newWriter, _readMapAndClose, _readTreeAndClose, _readValue, _serializerProvider, _unwrapAndDeserialize, _verifyNoTrailingTokens, _verifySchemaType, acceptJsonFormatVisitor, acceptJsonFormatVisitor, addHandler, addMixIn, addMixInAnnotations, canDeserialize, canDeserialize, canSerialize, canSerialize, clearProblemHandlers, configOverride, configure, configure, configure, configure, configure, constructType, convertValue, convertValue, convertValue, createArrayNode, createDeserializationContext, createObjectNode, defaultClassIntrospector, disable, disable, disable, disable, disable, disable, disable, disableDefaultTyping, enable, enable, enable, enable, enable, enable, enable, enableDefaultTyping, enableDefaultTyping, enableDefaultTyping, enableDefaultTypingAsProperty, findAndRegisterModules, findMixInClassFor, findModules, findModules, generateJsonSchema, getDateFormat, getDeserializationConfig, getDeserializationContext, getInjectableValues, getJsonFactory, getNodeFactory, getPropertyNamingStrategy, getSerializationConfig, getSerializerFactory, getSerializerProvider, getSerializerProviderInstance, getSubtypeResolver, getTypeFactory, getVisibilityChecker, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, mixInCount, reader, reader, reader, reader, reader, reader, reader, reader, reader, reader, reader, readerFor, readerFor, readerFor, readerForUpdating, readerWithView, readTree, readTree, readTree, readTree, readTree, readTree, readTree, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValue, readValues, readValues, readValues, readValues, registerModule, registerModules, registerModules, registerSubtypes, registerSubtypes, registerSubtypes, setAnnotationIntrospector, setAnnotationIntrospectors, setBase64Variant, setConfig, setConfig, setDateFormat, setDefaultMergeable, setDefaultPrettyPrinter, setDefaultPropertyInclusion, setDefaultPropertyInclusion, setDefaultSetterInfo, setDefaultTyping, setDefaultVisibility, setFilterProvider, setFilters, setHandlerInstantiator, setInjectableValues, setLocale, setMixInAnnotations, setMixInResolver, setMixIns, setNodeFactory, setPropertyInclusion, setPropertyNamingStrategy, setSerializationInclusion, setSerializerFactory, setSerializerProvider, setSubtypeResolver, setTimeZone, setTypeFactory, setVisibility, setVisibility, setVisibilityChecker, treeAsTokens, treeToValue, updateValue, valueToTree, writer, writer, writer, writer, writer, writer, writer, writer, writer, writer, writerFor, writerFor, writerFor, writerWithDefaultPrettyPrinter, writerWithType, writerWithType, writerWithType, writerWithView, writeTree, writeTree, writeValue, writeValue, writeValue, writeValue, writeValue, writeValueAsBytes, writeValueAsString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _schemaLoader

          protected ProtobufSchemaLoader _schemaLoader

    - #### _descriptorLoader

          protected DescriptorLoader _descriptorLoader

      Lazily constructed instance of `DescriptorLoader`, used for loading structured protoc definitions from multiple files.
      Since:
        2.9

  - ### Constructor Detail

    - #### ProtobufMapper

          public ProtobufMapper()

    - #### ProtobufMapper

          public ProtobufMapper(ProtobufFactory f)

    - #### ProtobufMapper

          protected ProtobufMapper(ProtobufMapper src)

  - ### Method Detail

    - #### copy

          public ProtobufMapper copy()

      Overrides:
        `copy` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### version

          public com.fasterxml.jackson.core.Version version()

      Specified by:
        `version` in interface `com.fasterxml.jackson.core.Versioned`
      Overrides:
        `version` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### getFactory

          public ProtobufFactory getFactory()

      Overrides:
        `getFactory` in class `com.fasterxml.jackson.databind.ObjectMapper`

    - #### schemaLoader

          public ProtobufSchemaLoader schemaLoader()

      Accessor for reusable `ProtobufSchemaLoader` which can be used for loading protoc definitions from files and other external sources.

    - #### setSchemaLoader

          public void setSchemaLoader(ProtobufSchemaLoader l)

    - #### generateSchemaFor

          public ProtobufSchema generateSchemaFor(com.fasterxml.jackson.databind.JavaType type)
                                           throws com.fasterxml.jackson.databind.JsonMappingException

      Convenience method for constructing protoc definition that matches given Java type. Uses `ProtobufSchemaGenerator` for generation.
      Throws:
        `com.fasterxml.jackson.databind.JsonMappingException`
      Since:
        2.8

    - #### generateSchemaFor

          public ProtobufSchema generateSchemaFor(Class<?> type)
                                           throws com.fasterxml.jackson.databind.JsonMappingException

      Convenience method for constructing protoc definition that matches given Java type. Uses `ProtobufSchemaGenerator` for generation.
      Throws:
        `com.fasterxml.jackson.databind.JsonMappingException`
      Since:
        2.8

    - #### loadDescriptorSet

          public FileDescriptorSet loadDescriptorSet(URL src)
                                              throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### loadDescriptorSet

          public FileDescriptorSet loadDescriptorSet(File src)
                                              throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### loadDescriptorSet

          public FileDescriptorSet loadDescriptorSet(InputStream src)
                                              throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### descriptorLoader

          public DescriptorLoader descriptorLoader()
                                            throws IOException

      Accessors that may be used instead of convenience `loadDescriptorSet` methods, if alternate sources need to be used.
      Throws:
        `IOException`
      Since:
        2.9

Copyright © 2017 FasterXML. All rights reserved.